#include "proto.h"
#include <stdarg.h>

u32 arc4random();
void arc4random_addrandom(byte *dat, int datlen);
void arc4random_stir();
byte arc4random_byte();
char *xf(const char *fmt, ...);
char *vxf(const char *fmt, va_list ap);
void init_home_dir();
char *count_md5(char *);

/* detach info: %d%s : port, password */

/* ========== */
extern int alloc_print;
void do_xfree(void *p, const char *s, int line);
void *do_xmalloc(int n, const char *s, int line);
void *do_xrealloc(void *, int n, const char *s, int line);
char *do_xstrdup(const char*, const char *s, int line);
char *do_xstrndup(const char *src, int n, const char *f, int l);
char *do_xf(const char *f, int l, const char *fmt, ...);
char *do_vxf(const char *f, int l, const char *fmt, va_list ap);

#ifdef ALLOC_DEBUG
#define xmalloc(n) do_xmalloc(n, __FILE__, __LINE__)
#define xstrdup(n) do_xstrdup(n, __FILE__, __LINE__)
#define xstrndup(n,a) do_xstrndup(n, a, __FILE__, __LINE__)
#define xrealloc(n,a) do_xrealloc(n, a, __FILE__, __LINE__)
#define xfree(p) do_xfree(p, __FILE__, __LINE__)
#define xf(a...) do_xf(__FILE__, __LINE__, a)
#define vxf(a...) do_vxf(__FILE__, __LINE__, a)
#else
void *xmalloc(int n);
void *xrealloc(void *p, int n);
void xfree(void *p);
char *xstrdup(const char *p);
char *xstrndup(const char *src, int n);
char *vxf(const char *fmt, va_list ap);
char *xf(const char *fmt, ...);
#endif

void xinfo(u32, u32);

extern char *home_dir;
