#include "config.h"
#include "lib.h"

#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "md5.h"

char *home_dir;

void init_home_dir()
{
	if (home_dir)
		goto bye;

	if (getenv("CONFIG_DIR"))
		home_dir = xf("%s/schiza", getenv("HOME_DIR"));
	else if (getenv("HOME"))
		home_dir = xf("%s/.schiza", getenv("HOME"));
	else
		home_dir = xstrdup("/home/.schiza");	// ???
	if (chdir(home_dir)) {
		mkdir(home_dir, 0700);
		chdir(home_dir);
	}
	if (chdir("screens"))
		mkdir("screens", 0700);
bye:
	chdir(home_dir);
}

char *count_md5(char *pass)
{
	char res[16], junk[33];
	int i;

	md5_buffer(pass, strlen(pass), res);
	
	junk[32] = 0;
	for (i = 0; i < 16; i++) {
		junk[i * 2] = (res[i] & 0xf) + 'a';
		junk[i * 2 + 1] = ((res[i] >> 4) & 0xf) + 'a';
	}
	return xstrdup(junk);
}
